Draft Facebinder/ru: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
(Updating to match new version of source page)
 
(16 intermediate revisions by 2 users not shown)
Line 1: Line 1:
<languages/>
<languages/>

{{Docnav
|[[Draft_Point|Point]]
|[[Draft_ShapeString|ShapeString]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Point.svg
|IconR=Draft_ShapeString.svg
|IconC=Workbench_Draft.svg
}}

<div class="mw-translate-fuzzy">
<div class="mw-translate-fuzzy">
{{GuiCommand/ru
{{GuiCommand/ru
|Name=Draft Facebinder
|Name=Draft Facebinder
|Name/ru=Draft Facebinder
|Name/ru=Draft Facebinder
|Workbenches=[[Draft Module/ru|Draft]], [[Arch Module/ru|Arch]]
|MenuLocation=Черчение → Граневяз
|MenuLocation=Черчение → Граневяз
|Workbenches=[[Draft_Workbench/ru|Draft]], [[Arch_Workbench/ru|Arch]]
|Shortcut=F F
|Shortcut={{KEY|F}} {{KEY|F}}
}}
}}
</div>
</div>


<span id="Description"></span>
==Описание==
==Описание==


Line 16: Line 27:
</div>
</div>


It can be used to create an extrusion from a collection of faces from other objects. A typical use is in architectural design to build an object that covers several walls, for example, a wall paper, or wall finish.
It can be used to create an extrusion from a collection of faces. This extrusion can for example represent a wall finish in architectural design.


[[Image:Draft facebinder example.jpg|400px]]
[[Image:Draft_facebinder_example.jpg|400px]]
{{Caption|Facebinder created from the faces of solid walls}}
{{Caption|Facebinder created from the faces of walls}}


<span id="Usage"></span>
==Использование==
==Использование==


# Pick one face, or hold {{KEY|Ctrl}} and pick several faces, from solid objects.
# Select one or more faces.
# There are several ways to invoke the command:
# Press the {{Button|[[Image:Draft_Facebinder.png|16px]] [[Draft_Facebinder|Facebinder]]}} button, or press {{KEY|F}} then {{KEY|F}} keys.
#* Press the {{Button|[[Image:Draft_Facebinder.svg|16px]] [[Draft_Facebinder|Facebinder]]}} button.
#* Select the {{MenuCommand|Drafting → [[Image:Draft_Facebinder.svg|16px]] Facebinder}} option from the menu.
#* Use the keyboard shortcut: {{KEY|F}} then {{KEY|F}}.


== Properties ==
The Facebinder can be edited by double clicking on the element in the tree view. Then you can change the faces that are part of the object.
* To add a face, click on a face of a solid object in the 3D view, and then click on the {{Button|[[Image:Arch_Add.svg|16px]] Add}} button.
* To remove a face, select one of the sub-elements in the list, and then click on the {{Button|[[Image:Arch_Remove.svg|16px]] Remove}} button.
* Press {{KEY|Esc}} or the {{Button|OK}} button to complete the edition.


See also: [[Property_editor|Property editor]].
== Options ==
This object has no options when it's being created. Only selected faces will be used to create the Facebinder object.


A Draft Facebinder object is derived from a [[Part_Feature|Part Feature]] object and inherits all its properties. It also has the following additional properties:
== Properties ==

=== Data ===
===Data===
* {{PropertyData|Extrusion}}: specifies an extrusion thickness to apply to all faces of the shape.

* {{PropertyData|Remove Splitter}}: if it is {{TRUE}} it tries to fuse the internal intersections of the Facebinder when it extruded.
{{TitleProperty|Draft}}
* {{PropertyData|Sew}}: if it is {{TRUE}} it tries to perform a topological sewing operation on the Facebinder when it extruded.

* {{PropertyData|Area|Area}}: (read-only) specifies the total area of the linked faces of the facebinder.
* {{PropertyData|Extrusion|Distance}}: specifies the extrusion thickness of the facebinder.
* {{PropertyData|Faces|LinkSubList}}: specifies the linked faces of the facebinder.
* {{PropertyData|Offset|Distance}}: specifies an offset distance to apply between the facebinder and the original faces, prior to extrusion.
* {{PropertyData|Remove Splitter|Bool}}: Specifies whether to remove splitter lines that divide co-planar faces of the facebinder.
* {{PropertyData|Sew|Bool}}: Specifies whether to perform a topological sewing operation on the facebinder.


=== View ===
=== View ===

* {{PropertyView|Pattern}}: specifies a [[Draft Pattern]] with which to fill the face of the shape. This property only works if {{PropertyView|Display Mode}} is "Flat Lines".
{{TitleProperty|Draft}}
* {{PropertyView|Pattern Size}}: specifies the size of the [[Draft Pattern]].

* {{PropertyView|Pattern|Enumeration}}: specifies the [[Draft_Pattern|Draft Pattern]] with which to fill the faces of the facebinder. This property only works if {{PropertyView|Display Mode}} is {{value|Flat Lines}}.
* {{PropertyView|Pattern Size|Float}}: specifies the size of the [[Draft_Pattern|Draft Pattern]].


==Scripting==
==Scripting==
{{Emphasis|See also:}} [[Draft API]] and [[FreeCAD Scripting Basics]].


See also: [https://freecad.github.io/SourceDoc/ Autogenerated API documentation] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].
The Facebinder tool can be used in [[macros]] and from the [[Python]] console by using the following function:

To create a Draft Facebinder use the {{incode|make_facebinder}} method ({{Version|0.19}}) of the Draft module. This method replaces the deprecated {{incode|makeFacebinder}} method.

{{Code|code=
{{Code|code=
Facebinder = makeFacebinder(selectionset, name="Facebinder")
facebinder = make_facebinder(selectionset)
}}
}}
* Creates a {{incode|Facebinder}} object from the given {{incode|selectionset}}, which is a list of {{incode|SelectionObject}}s such as those returned by {{incode|FreeCADGui.Selection.getSelectionEx()}}.
* Only selected faces are taken into account.


* Creates a {{incode|facebinder}} object from the given {{incode|selectionset}}, which is a list of {{incode|SelectionObject}}s as returned by {{incode|FreeCADGui.Selection.getSelectionEx()}}. Only selected faces are taken into account.
The thickness of the ShapeString can be added by overwriting its {{incode|Extrusion}} attribute; the value is entered in millimeters.
** {{incode|selectionset}} can also be a {{incode|PropertyLinkSubList}}.
A {{incode|PropertyLinkSubList}} is a list of tuples; each tuple contains as first element an {{incode|object}}, and as second element a list (or tuple) of strings; these strings indicate the names of the sub-elements (faces) of that object.


{{Code|code=
The placement of the ShapeString can be changed by overwriting its {{incode|Placement}} attribute, or by individually overwriting its {{incode|Placement.Base}} and {{incode|Placement.Rotation}} attributes.
PropertyLinkSubList = [tuple1, tuple2, tuple3, ...]
PropertyLinkSubList = [(object1, list1), (object2, list2), (object3, list3), ...]
PropertyLinkSubList = [(object1, ['Face1', 'Face4', 'Face6']), ...]
PropertyLinkSubList = [(object1, ('Face1', 'Face4', 'Face6')), ...]
}}

The thickness of the Facebinder can be added by overwriting its {{incode|Extrusion}} attribute; the value is entered in millimeters.

The placement of the Facebinder can be changed by overwriting its {{incode|Placement}} attribute, or by individually overwriting its {{incode|Placement.Base}} and {{incode|Placement.Rotation}} attributes.


Example:
Example:

{{Code|code=
{{Code|code=
import FreeCAD, FreeCADGui, Draft
import FreeCAD as App
import FreeCADGui as Gui
import Draft

doc = App.newDocument()


# Insert a solid box
# Insert a solid box
Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
box = doc.addObject("Part::Box", "Box")
Box.Length = 2300
box.Length = 2300
Box.Width = 800
box.Width = 800
Box.Height = 1000
box.Height = 1000

# selection = Gui.Selection.getSelectionEx()
selection = [(box, ("Face1", "Face6"))]
facebinder = Draft.make_facebinder(selection)
facebinder.Extrusion = 50

doc.recompute()

facebinder.Placement.Base = App.Vector(1000, -1000, 100)
facebinder.ViewObject.ShapeColor = (0.99, 0.99, 0.4)

doc.recompute()
}}


# Pick any two side faces, and then
selection = FreeCADGui.Selection.getSelectionEx()
Facebinder = Draft.makeFacebinder(selection)
Facebinder.Extrusion = 50
FreeCAD.ActiveDocument.recompute()


{{Docnav
Facebinder.Placement.Base = FreeCAD.Vector(1000, -1000, 100)
|[[Draft_Point|Point]]
Facebinder.ViewObject.ShapeColor = (0.99, 0.99, 0.4)
|[[Draft_ShapeString|ShapeString]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Point.svg
|IconR=Draft_ShapeString.svg
|IconC=Workbench_Draft.svg
}}
}}


{{Draft Tools navi}}
{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi}}
{{Userdocnavi{{#translation:}}}}
{{clear}}

Latest revision as of 19:32, 7 December 2023

Draft Facebinder

Системное название
Draft Facebinder
Расположение в меню
Черчение → Граневяз
Верстаки
Draft, Arch
Быстрые клавиши
F F
Представлено в версии
-
См. также
Нет

Описание

Facebinder - очень простой объект, построенный из выбранных лиц других объектов. Он параметрический, вы можете соответствующим образом изменить исходный объект и объекты объекта facebinder. Затем его можно использовать, например, для изготовления экструзии из коллекции лиц из других объектов. Типичное использование в архитектурном дизайне, построение объекта, который покрывает несколько кусков стен. Вы можете перемещать и поворачивать facebinder вокруг после его создания, все будет оставаться связанным с оригинальными лицами.

It can be used to create an extrusion from a collection of faces. This extrusion can for example represent a wall finish in architectural design.

Facebinder created from the faces of walls

Использование

  1. Select one or more faces.
  2. There are several ways to invoke the command:
    • Press the Facebinder button.
    • Select the Drafting → Facebinder option from the menu.
    • Use the keyboard shortcut: F then F.

Properties

See also: Property editor.

A Draft Facebinder object is derived from a Part Feature object and inherits all its properties. It also has the following additional properties:

Data

Draft

  • ДанныеArea (Area): (read-only) specifies the total area of the linked faces of the facebinder.
  • ДанныеExtrusion (Distance): specifies the extrusion thickness of the facebinder.
  • ДанныеFaces (LinkSubList): specifies the linked faces of the facebinder.
  • ДанныеOffset (Distance): specifies an offset distance to apply between the facebinder and the original faces, prior to extrusion.
  • ДанныеRemove Splitter (Bool): Specifies whether to remove splitter lines that divide co-planar faces of the facebinder.
  • ДанныеSew (Bool): Specifies whether to perform a topological sewing operation on the facebinder.

View

Draft

  • ВидPattern (Enumeration): specifies the Draft Pattern with which to fill the faces of the facebinder. This property only works if ВидDisplay Mode is Flat Lines.
  • ВидPattern Size (Float): specifies the size of the Draft Pattern.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a Draft Facebinder use the make_facebinder method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeFacebinder method.

facebinder = make_facebinder(selectionset)
  • Creates a facebinder object from the given selectionset, which is a list of SelectionObjects as returned by FreeCADGui.Selection.getSelectionEx(). Only selected faces are taken into account.
    • selectionset can also be a PropertyLinkSubList.

A PropertyLinkSubList is a list of tuples; each tuple contains as first element an object, and as second element a list (or tuple) of strings; these strings indicate the names of the sub-elements (faces) of that object.

PropertyLinkSubList = [tuple1, tuple2, tuple3, ...]
PropertyLinkSubList = [(object1, list1), (object2, list2), (object3, list3), ...]
PropertyLinkSubList = [(object1, ['Face1', 'Face4', 'Face6']), ...]
PropertyLinkSubList = [(object1, ('Face1', 'Face4', 'Face6')), ...]

The thickness of the Facebinder can be added by overwriting its Extrusion attribute; the value is entered in millimeters.

The placement of the Facebinder can be changed by overwriting its Placement attribute, or by individually overwriting its Placement.Base and Placement.Rotation attributes.

Example:

import FreeCAD as App
import FreeCADGui as Gui
import Draft

doc = App.newDocument()

# Insert a solid box
box = doc.addObject("Part::Box", "Box")
box.Length = 2300
box.Width = 800
box.Height = 1000

# selection = Gui.Selection.getSelectionEx()
selection = [(box, ("Face1", "Face6"))]
facebinder = Draft.make_facebinder(selection)
facebinder.Extrusion = 50

doc.recompute()

facebinder.Placement.Base = App.Vector(1000, -1000, 100)
facebinder.ViewObject.ShapeColor = (0.99, 0.99, 0.4)

doc.recompute()